require 'watir-webdriver'
require 'selenium-webdriver'

module PowerSchool
    module Configuration
        VALID_OPTION_KEYS = %w(host username password browser).freeze

        HOST = nil
        USERNAME = nil
        PASSWORD = nil

        attr_accessor *VALID_OPTION_KEYS

        def self.extend(base)
            base.reset
        end

        def reset
            self.host = HOST
            self.username = USERNAME
            self.password = PASSWORD
        end

        def configure
            yield self

            client = Selenium::WebDriver::Remote::Http::Default.new
            client.timeout = 180 # seconds – default is 60

            self.browser ||= Watir::Browser.new :chrome, :http_client => client
        end
    end
end
