module PowerSchool
    class Connection

        def self.login
            PowerSchool.browser.goto PowerSchool.host + "pw.html"
            credentials = PowerSchool.username + ';' + PowerSchool.password
            PowerSchool.browser.text_field(:name => 'password').set credentials
            PowerSchool.browser.button(:id => "btnEnter").click
        end

        def self.logout
            PowerSchool.browser.link(:id => "btnLogout")
            PowerSchool.browser.close
        end


        def self.welcome_message
            PowerSchool.browser.li(:id, "userName").text
        end
        
        def self.go_home( additional_info = "" )
            PowerSchool.browser.goto PowerSchool.host + "home.html" + additional_info
        end

        def self.go_to( url )
            PowerSchool.browser.goto PowerSchool.host + url 
        end

        def self.select_school( school_name )
            go_home
            unless current_school == school_name 
                PowerSchool.browser.link(:id, "schoolContext").click
                PowerSchool.browser.wait_until{ PowerSchool.browser.select_list(:name, 'Schoolid').exists? }
                PowerSchool.browser.wait_until { PowerSchool.browser.select_list(:name, "Schoolid").select school_name }
            end
        end

        def self.current_school
            PowerSchool.browser.span(:id, "schoolText").text
        end

        def self.clear_form
            PowerSchool.browser.text_fields.each do |text|
                text.clear
            end
        end

        def self.quick_import( table_name, file_name)
            PowerSchool::Connection.go_to "importexport/quickimport/quickimport1.html"
            PowerSchool.browser.select_list(:id, "filenumber").select table_name 
            PowerSchool.browser.select_list(:id, "fielddelim").select "Other:"
            PowerSchool.browser.text_field(:id => 'custfielddelim').set ';'
            PowerSchool.browser.select_list(:id, "recdelim").select "LF"
            PowerSchool.browser.file_field(:id, "filename").set( file_name )
            PowerSchool.browser.button(:id => "btnImport").click

            PowerSchool.browser.checkbox(:name, "skipFirstRow").set
            
            if table_name == 'Teachers'
                PowerSchool.browser.checkbox(:name, "updaterecordsmode").set

            elsif table_name == 'Students'
                PowerSchool.browser.radio(:value, "createnew").set
                PowerSchool.browser.checkbox(:name, "AllowEnrollStatusUpdate").set
            end

            PowerSchool.browser.button(:id => "btnSubmit").click
        end

        def self.last_staff_id
            PowerSchool::Connection.go_to "tech/dde/"
            PowerSchool.browser.select_list(:name, "filenum").select_value "5"
            PowerSchool.browser.button(:name => "searchselectall").click
            PowerSchool::Connection.go_to "tech/dde/exportrecords.html"
            PowerSchool.browser.text_field(:id => "tt").set("ID")
            PowerSchool.browser.button(:id => "btnSubmit").click
        end
    end
end
